// Package models provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package models

// Defines values for Action.
const (
	FscAcceptContract                   Action = "fsc:AcceptContract"
	FscCreateContract                   Action = "fsc:CreateContract"
	FscCreatePeer                       Action = "fsc:CreatePeer"
	FscCreateService                    Action = "fsc:CreateService"
	FscDeleteService                    Action = "fsc:DeleteService"
	FscGetContract                      Action = "fsc:GetContract"
	FscGetPeerInfo                      Action = "fsc:GetPeerInfo"
	FscGetService                       Action = "fsc:GetService"
	FscListAuditlogs                    Action = "fsc:ListAuditlogs"
	FscListContractDistributions        Action = "fsc:ListContractDistributions"
	FscListContracts                    Action = "fsc:ListContracts"
	FscListDelegatedConnections         Action = "fsc:ListDelegatedConnections"
	FscListDelegatedServicePublications Action = "fsc:ListDelegatedServicePublications"
	FscListInways                       Action = "fsc:ListInways"
	FscListOutways                      Action = "fsc:ListOutways"
	FscListPeerServices                 Action = "fsc:ListPeerServices"
	FscListPeers                        Action = "fsc:ListPeers"
	FscListServicePublications          Action = "fsc:ListServicePublications"
	FscListServices                     Action = "fsc:ListServices"
	FscListTransactionLogs              Action = "fsc:ListTransactionLogs"
	FscRejectContract                   Action = "fsc:RejectContract"
	FscRetryContract                    Action = "fsc:RetryContract"
	FscRevokeContract                   Action = "fsc:RevokeContract"
	FscSyncPeers                        Action = "fsc:SyncPeers"
	FscUpdatePeer                       Action = "fsc:UpdatePeer"
	FscUpdateService                    Action = "fsc:UpdateService"
)

// Action Which action is to be authorized
type Action string

// AuthorizationRequest defines model for authorizationRequest.
type AuthorizationRequest struct {
	Input AuthorizationRequestInput `json:"input"`
}

// AuthorizationRequestInput defines model for authorizationRequestInput.
type AuthorizationRequestInput struct {
	// Action Which action is to be authorized
	Action Action `json:"action"`

	// Metadata Metadata of the request
	Metadata  Metadata `json:"metadata"`
	Resources []string `json:"resources"`
}

// AuthorizationResponse defines model for authorizationResponse.
type AuthorizationResponse struct {
	// Allowed true if the request is authorized. false when the authorization has failed.
	Allowed bool `json:"allowed"`

	// Reason Reason why the request was not authorized.
	Reason *string `json:"reason,omitempty"`
}

// Metadata Metadata of the request
type Metadata struct {
	// Headers Contains the HTTP-headers of the request made to the Controller
	Headers *map[string][]string `json:"headers,omitempty"`
}

// AuthorizeJSONRequestBody defines body for Authorize for application/json ContentType.
type AuthorizeJSONRequestBody = AuthorizationRequest
